/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-rail-user-queue-manager-0.0.2-0precise-20150508-1709/msg/Queue.msg
 *
 */


#ifndef RAIL_USER_QUEUE_MANAGER_MESSAGE_QUEUE_H
#define RAIL_USER_QUEUE_MANAGER_MESSAGE_QUEUE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <rail_user_queue_manager/UserStatus.h>

namespace rail_user_queue_manager
{
template <class ContainerAllocator>
struct Queue_
{
  typedef Queue_<ContainerAllocator> Type;

  Queue_()
    : queue()  {
    }
  Queue_(const ContainerAllocator& _alloc)
    : queue(_alloc)  {
    }



   typedef std::vector< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> >::other >  _queue_type;
  _queue_type queue;




  typedef boost::shared_ptr< ::rail_user_queue_manager::Queue_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::rail_user_queue_manager::Queue_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Queue_

typedef ::rail_user_queue_manager::Queue_<std::allocator<void> > Queue;

typedef boost::shared_ptr< ::rail_user_queue_manager::Queue > QueuePtr;
typedef boost::shared_ptr< ::rail_user_queue_manager::Queue const> QueueConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::rail_user_queue_manager::Queue_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::rail_user_queue_manager::Queue_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace rail_user_queue_manager

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'rail_user_queue_manager': ['/tmp/buildd/ros-hydro-rail-user-queue-manager-0.0.2-0precise-20150508-1709/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::rail_user_queue_manager::Queue_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::rail_user_queue_manager::Queue_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rail_user_queue_manager::Queue_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rail_user_queue_manager::Queue_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rail_user_queue_manager::Queue_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rail_user_queue_manager::Queue_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::rail_user_queue_manager::Queue_<ContainerAllocator> >
{
  static const char* value()
  {
    return "36de446b5be16dcdfb7534f21a812ca2";
  }

  static const char* value(const ::rail_user_queue_manager::Queue_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x36de446b5be16dcdULL;
  static const uint64_t static_value2 = 0xfb7534f21a812ca2ULL;
};

template<class ContainerAllocator>
struct DataType< ::rail_user_queue_manager::Queue_<ContainerAllocator> >
{
  static const char* value()
  {
    return "rail_user_queue_manager/Queue";
  }

  static const char* value(const ::rail_user_queue_manager::Queue_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::rail_user_queue_manager::Queue_<ContainerAllocator> >
{
  static const char* value()
  {
    return "UserStatus[] queue  # The main queue information\n\
\n\
================================================================================\n\
MSG: rail_user_queue_manager/UserStatus\n\
uint32 user_id      # The user ID\n\
duration wait_time  # Estimated wait time\n\
duration time_left  # Time left for active user\n\
";
  }

  static const char* value(const ::rail_user_queue_manager::Queue_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::rail_user_queue_manager::Queue_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.queue);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Queue_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::rail_user_queue_manager::Queue_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::rail_user_queue_manager::Queue_<ContainerAllocator>& v)
  {
    s << indent << "queue[]" << std::endl;
    for (size_t i = 0; i < v.queue.size(); ++i)
    {
      s << indent << "  queue[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::rail_user_queue_manager::UserStatus_<ContainerAllocator> >::stream(s, indent + "    ", v.queue[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // RAIL_USER_QUEUE_MANAGER_MESSAGE_QUEUE_H
