/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-rail-user-queue-manager-0.0.2-0precise-20150508-1709/srv/UpdateQueue.srv
 *
 */


#ifndef RAIL_USER_QUEUE_MANAGER_MESSAGE_UPDATEQUEUEREQUEST_H
#define RAIL_USER_QUEUE_MANAGER_MESSAGE_UPDATEQUEUEREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace rail_user_queue_manager
{
template <class ContainerAllocator>
struct UpdateQueueRequest_
{
  typedef UpdateQueueRequest_<ContainerAllocator> Type;

  UpdateQueueRequest_()
    : user_id(0)
    , enqueue(false)
    , study_time(0)  {
    }
  UpdateQueueRequest_(const ContainerAllocator& _alloc)
    : user_id(0)
    , enqueue(false)
    , study_time(0)  {
    }



   typedef uint32_t _user_id_type;
  _user_id_type user_id;

   typedef uint8_t _enqueue_type;
  _enqueue_type enqueue;

   typedef uint32_t _study_time_type;
  _study_time_type study_time;




  typedef boost::shared_ptr< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct UpdateQueueRequest_

typedef ::rail_user_queue_manager::UpdateQueueRequest_<std::allocator<void> > UpdateQueueRequest;

typedef boost::shared_ptr< ::rail_user_queue_manager::UpdateQueueRequest > UpdateQueueRequestPtr;
typedef boost::shared_ptr< ::rail_user_queue_manager::UpdateQueueRequest const> UpdateQueueRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace rail_user_queue_manager

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'rail_user_queue_manager': ['/tmp/buildd/ros-hydro-rail-user-queue-manager-0.0.2-0precise-20150508-1709/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "8ec51f44b77714c4490c721cbc2e5ab6";
  }

  static const char* value(const ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x8ec51f44b77714c4ULL;
  static const uint64_t static_value2 = 0x490c721cbc2e5ab6ULL;
};

template<class ContainerAllocator>
struct DataType< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "rail_user_queue_manager/UpdateQueueRequest";
  }

  static const char* value(const ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "uint32 user_id\n\
bool enqueue\n\
uint32 study_time\n\
";
  }

  static const char* value(const ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.user_id);
      stream.next(m.enqueue);
      stream.next(m.study_time);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct UpdateQueueRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::rail_user_queue_manager::UpdateQueueRequest_<ContainerAllocator>& v)
  {
    s << indent << "user_id: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.user_id);
    s << indent << "enqueue: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.enqueue);
    s << indent << "study_time: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.study_time);
  }
};

} // namespace message_operations
} // namespace ros

#endif // RAIL_USER_QUEUE_MANAGER_MESSAGE_UPDATEQUEUEREQUEST_H
